import React from 'react';
import styled, { createGlobalStyle } from 'styled-components';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
}

/**
 * 버튼입니다
 */

var MyButton = function MyButton(_a) {
  var children = _a.children,
      props = __rest(_a, ["children"]);

  return /*#__PURE__*/React.createElement(StyledButtonWrapper, null, /*#__PURE__*/React.createElement("button", __assign({}, props), children));
};

MyButton.defaultProps = {
  disabled: false
};
var StyledButtonWrapper = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  > button {\n    background-color: ", ";\n  }\n"], ["\n  > button {\n    background-color: ", ";\n  }\n"])), function (props) {
  return props.theme.colors.primary;
});
var MyButton$1 = /*#__PURE__*/React.memo(MyButton);
var templateObject_1;

/**
 * 어두운 테마이다.
 */
var Dark = {
  colors: {
    pageBackground: '#333333',
    primary: '#fafafa'
  }
};

/**
 * 밝은 테마이다.
 */
var Light = {
  colors: {
    pageBackground: '#fcfcfc',
    primary: '#333333'
  }
};

/**
 * 테마 타입을 모아서 export 한다.
 * 해당 테마는 사용하는 클리이언트에서 ThemeProvider에 주입한다.
 */

var theme = {
  light: Light,
  dark: Dark
};

function unwrapExports (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var dist = createCommonjsModule(function (module, exports) {

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Normalize = exports.normalize = void 0;



var normalize = (0, styled.css)(["html{line-height:1.15;-webkit-text-size-adjust:100%;}body{margin:0;}main{display:block;}h1{font-size:2em;margin:0.67em 0;}hr{box-sizing:content-box;height:0;overflow:visible;}pre{font-family:monospace,monospace;font-size:1em;}a{background-color:transparent;}abbr[title]{border-bottom:none;text-decoration:underline;text-decoration:underline dotted;}b,strong{font-weight:bolder;}code,kbd,samp{font-family:monospace,monospace;font-size:1em;}small{font-size:80%;}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline;}sub{bottom:-0.25em;}sup{top:-0.5em;}img{border-style:none;}button,input,optgroup,select,textarea{font-family:inherit;font-size:100%;line-height:1.15;margin:0;}button,input{overflow:visible;}button,select{text-transform:none;}button,[type=\"button\"],[type=\"reset\"],[type=\"submit\"]{-webkit-appearance:button;}button::-moz-focus-inner,[type=\"button\"]::-moz-focus-inner,[type=\"reset\"]::-moz-focus-inner,[type=\"submit\"]::-moz-focus-inner{border-style:none;padding:0;}button:-moz-focusring,[type=\"button\"]:-moz-focusring,[type=\"reset\"]:-moz-focusring,[type=\"submit\"]:-moz-focusring{outline:1px dotted ButtonText;}fieldset{padding:0.35em 0.75em 0.625em;}legend{box-sizing:border-box;color:inherit;display:table;max-width:100%;padding:0;white-space:normal;}progress{vertical-align:baseline;}textarea{overflow:auto;}[type=\"checkbox\"],[type=\"radio\"]{box-sizing:border-box;padding:0;}[type=\"number\"]::-webkit-inner-spin-button,[type=\"number\"]::-webkit-outer-spin-button{height:auto;}[type=\"search\"]{-webkit-appearance:textfield;outline-offset:-2px;}[type=\"search\"]::-webkit-search-decoration{-webkit-appearance:none;}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit;}details{display:block;}summary{display:list-item;}template{display:none;}[hidden]{display:none;}"]);
exports.normalize = normalize;
var Normalize = (0, styled.createGlobalStyle)(normalize);
exports.Normalize = Normalize;
var _default = normalize;
exports.default = _default;
});

unwrapExports(dist);
var dist_1 = dist.Normalize;
var dist_2 = dist.normalize;

/**
 * Storybook 모든 컴포넌트에서 적용될 Global Style
 * 모듈로 export 할 때도 포함되어야 한다.
 * 그리고 사용하는 쪽에서도 App.tsx 같은 최상위 컴포넌트에서 렌더링해야 한다.
 */

var GlobalStyle = createGlobalStyle(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n    ", "\n    * {\n        outline: none;\n    }\n"], ["\n    ", "\n    * {\n        outline: none;\n    }\n"])), dist_2);
var templateObject_1$1;

export { GlobalStyle, MyButton$1 as MyButton, theme };
